<html>

<head>
  <title>Procurando e copiando arquivos com seus caminhos originais</title>
  <meta http-equiv="Content-Type" content="text/html; charset=utf8">
  <link rel="stylesheet"    href="style.css" type="text/css">
  <link rel="shortcut icon" href="favicon.ico">
</head>

<body>

<h1>Procurando e copiando arquivos com seus caminhos originais</h1>

<p>Ao longo dos anos fui amontoando alguns arquivos .reg com configuração personalizada do PuTTY. Não é muita coisa, mas está tudo espalhado em um HD USB com mais de 1 TiB de dados e não há a menor chance de lembrar quantos são, em que diretórios estão e como se chamam; só sei que provavelmente têm "putty" no nome, alguma alternância entre maiúsculo e minúsculo, e a extensão é "reg".</p>
<p>Como achá-los e copiá-los automaticamente para um único diretório, cuidando para não sobrescrever os que tiverem o mesmo nome? Bom, se cada arquivo for copiado com seu caminho original para dentro do novo diretório "pai", certamente não haverá nenhuma sobreposição.</p>
<p>A <b>primeira técnica</b> será a forma rápida, limpa e suficientemente nerd de fazer isso (no Unix, MacOSX e Windows com <a href="http://goo.gl/lu6oJi">CygWin</a>): com um singelo <i>cp</i> associado a um <i>find</i>.</p>
<p>Primeiro preparamos adequadamente o ambiente:</p>

<pre>
  $ padrao="*putty*.reg"
  $ pesquisa="/longa/raiz/comum/a/todos/os/arquivos/e/que/nao/interessa/manter/"
  $ destino="/diretorio/para/os/arquivos/encontrados/"
  $ mkdir -p "$destino"
  $ alias time="/usr/bin/time -f %E"
</pre>

<p>Então executamos o comando:</p>

<pre>
  $ ( cd "$pesquisa"; cp -va --parents $(time find . -type f -iname "$padrao") "$destino" )
</pre>

<p>O <i>alias</i> do comando <i>time</i> é apenas um plus a mais :-p para saber em um formato user friendly quanto tempo a pesquisa do <i>find</i> demorou.</p>
<p>Beleza, funcionou! Em 17 min varreu 1.3 TiB e copiou 28 arquivos.</p>
<p>Mas como nem tudo são flores no mundo encantado da TI, esse método tem pelo menos dois pontos de falha em potencial.</p>
<p>Um deles é o tamanho da entrada gerada pela saída do <i>find</i>. No meu Linux 3.16.0 em arquitetura 32 bits, se todos os argumentos do <i>cp</i> resultarem em uma string com mais de 2.097.152 (=2^21, <code>bc -l &lt;&lt;&lt; "scale=5;l(2097152)/l(2)"</code> ;-) caracteres, ele vai reclamar:</p>

<pre>
  $ ( cd "$pesquisa"; find . -type f -iname "$padrao" | wc -c ) # mostra com quantos bytes fica a lista de argumentos resultante do padrão
  2981219
  $ ( cd "$pesquisa"; cp -va --parents $(find . -type f -iname "$padrao") "$destino" )
  bash: /bin/cp: Lista de argumentos muito longa
  $ # ou, em inglês:
  $ ( cd "$pesquisa"; LANGUAGE=C cp -va --parents $(find . -type f -iname "$padrao") "$destino" )
  bash: /bin/cp: Argument list too long
</pre>

<p>Podemos até não gostar dessa limitação de 2 MiB, mas lembremos que o "comprimento" dos comandos no terminal do Windows não passa de míseros (8Ki-1)B &gt;:-) (<a href="http://goo.gl/Yo1m1e">support.microsoft.com/pt-br/kb/830473</a>)</p>
<p>O tamanho que a lista de argumentos pode ter no Unix está definido na constante <b>ARG_MAX</b> e, pelo menos no Linux, pode ser consultado com o comando <i>getconf</i>:</p>

<pre>
  $ getconf ARG_MAX   2097152
  $ getconf -a            # todos as constantes
  $ getconf -a | grep MAX # constantes explicitamente relacionadas a limites máximos, vale a pena uma olhada
</pre>

<p>Alguma informação sobre o <b>ARG_MAX</b> está disponível em <a href="http://goo.gl/rvN5B5">in-ulm.de/~mascheck/various/argmax/</a>, inclusive uma tabela comparando seu valor em vários sistemas operacionais.</p>
<p>Ainda que o processo sobreviva ao risco do tamanho final da lista de parâmetros do <i>cp</i>, pode não escapar da existência de diretórios ou arquivos com espaço no nome (<code>/longa/raiz/</code><b><code>comum a</code></b><code>/todos/os/arquivos/e/que/nao/interessa/manter/configs/</code><b><code>putty fileserver.reg</code></b>):</p>

<pre>
  cp: impossível obter estado de  /longa/raiz/comum : Arquivo ou diretório não encontrado
  cp: impossível obter estado de  a/todos/os/arquivos/e/que/nao/interessa/manter/configs/putty : Arquivo ou diretório não encontrado
  cp: impossível obter estado de  fileserver.reg : Arquivo ou diretório não encontrado
</pre>

<p>Para contornar esse outro ponto de falha, precisamos de alguma técnica que permita deixar entre aspas o nome com caminho de cada arquivo, ou o que quer que o represente.</p>
<p>Ignorando a alternativa óbvia de iterar a saída do <i>find</i> em um loop, uma <b>segunda técnica</b> permite driblar simultaneamente o problema do tamanho da lista de argumentos e dos espaços em nomes, de pelo menos duas formas:</p>

<ul>
<li>executando o <i>cp</i> de dentro do <i>find</i></li>
<li>passando o resultado do <i>find</i> via <i>xargs</i> para o <i>cp</i></li>
</ul>

<pre>
  $ ( cd "$pesquisa"; time find . -type f -iname "$padrao" -exec cp -va --parents "{}" "$destino" \; )
  $ ( cd "$pesquisa"; time find . -type f -iname "$padrao" | xargs -I+ cp -va --parents "+" "$destino" )
</pre>

<p>Por fim, uma <b>terceira técnica</b> combina o comando <i>find</i> com duas chamadas do comando <i>tar</i>. Tem características interessantes:</p>

<ul>
<li>é possível compactar o stream antes da cópia, usando parâmetros do próprio <i>tar</i> ou alguma ferramenta auxiliar;</li>
<li>aliando o comando <i>ssh</i>, é possível transferência criptografada do stream através pela rede;</li>
<li>uma chave privada sem passphrase para o <i>ssh</i> torna desnecessária a interação humana para autenticação por senha;</li>
<li>além da compressão por ferramentas auxiliares, o próprio <i>ssh</i> pode efetuar compressão dos dados em seu tráfego. De qualquer forma, é basicamente em redes lentas que ela será útil de fato.</li>
</ul>

<p>Usando <i>ssh</i>, é especialmente importante verificar se temos as permissões necessárias para criar o diretório <b>$destino</b>.</p>
<p>O <i>tar</i> pode ser usado com <i>xargs</i> para contornar o estouro do tamanho da lista de argumentos ou pode usar um arquivo com a lista de entrada a ser manipulada. Para evitar a criação explícita de um arquivo intermediário, podemos aplicar substituição de processos (<a href="http://goo.gl/Yt7ofw">apoie.org/JulioNeves/PapoXI.htm#Substitui_o_de_processos</a>, <a href="http://goo.gl/IaSYQf">wikipedia.org/wiki/Process_substitution</a>).</p>

<pre>
  $ ( cd "$pesquisa"; time find . -type f -iname "$padrao" -print0 | xargs -0 tar cf - ) | tar xvf - -C "$destino"
  $ ( cd "$pesquisa"; tar  cf - -T &lt;(time find . -type f -iname "$padrao") ) | tar xvf - -C "$destino"

  $ chave="/arquivo/com/chave/privada/sem/passphrase"
  $ remoto="user@host"

  $ # compactação gzip
  $ ( cd "$pesquisa"; tar  cf - -T &lt;(time find . -type f -iname "$padrao") ) | ssh -CTi "$chave" $remoto "mkdir -p '$destino'; tar  xvf - -C '$destino'"    

  $ # compactação bzip2
  $ ( cd "$pesquisa"; tar jcf - -T &lt;(time find . -type f -iname "$padrao") ) | ssh  -Ti "$chave" $remoto "mkdir -p '$destino'; tar jxvf - -C '$destino'"    

  $ # compactação lzma
  $ ( cd "$pesquisa"; tar  cf - -T &lt;(time find . -type f -iname "$padrao") ) | xz -9e | ssh -Ti "$chave" $remoto "mkdir -p '$destino'; xz -d | tar xvf - -C '$destino'"
</pre>

<h2>Comandos usados nesse artigo</h2>

<ul>
<li><a href="http://goo.gl/xyWEUj">bash</a></li>
<li><a href="http://goo.gl/4lPnHa">cp</a></li>
<li><a href="http://goo.gl/BYfgvT">find</a></li>
<li><a href="http://goo.gl/ohvUEn">getconf</a></li>
<li><a href="http://goo.gl/KlxUdu">grep</a></li>
<li><a href="http://goo.gl/kyv1cP">ssh</a></li>
<li><a href="http://goo.gl/uZkT7k">tar</a></li>
<li><a href="http://goo.gl/XOYu6o">time</a></li>
<li><a href="http://goo.gl/ad8FI7">wc</a></li>
<li><a href="http://goo.gl/v2LCEa">xargs</a></li>
<li><a href="http://goo.gl/39LKqs">xz</a></li>
</ul>

</body>

</html>
